#include "mesh.h"
#include "decl_mesh.h"

_mesh_ *charge_mesh(char *fichier, LPDIRECT3DDEVICE9 *_obj_Direct3DDevice) {

	_mesh_ *mtm = new _mesh_;

	// charge le fichier Mesh
	LPD3DXBUFFER Mat_buff = NULL; //matriaux du mesh buffeuriss
	if(FAILED(D3DXLoadMeshFromX((const char*)fichier, D3DXMESH_SYSTEMMEM, *_obj_Direct3DDevice, NULL, &Mat_buff, NULL, &mtm->nbr_de_mat, &mtm->obj_mesh)))
		return NULL;

	// extraction des proprits des matriaux
	D3DXMATERIAL *Prop_Mat = (D3DXMATERIAL*)Mat_buff->GetBufferPointer();

	mtm->Materiaux = new D3DMATERIAL9[mtm->nbr_de_mat];
	mtm->Textures = new LPDIRECT3DTEXTURE9[mtm->nbr_de_mat];

	for(unsigned int i = 0; i<mtm->nbr_de_mat; i++) {
		mtm->Materiaux[i] = Prop_Mat[i].MatD3D; // copie des matriaux
		mtm->Materiaux[i].Ambient = mtm->Materiaux[i].Diffuse; // definit la couleur ambiante du materiel

		// cration de la texture

		if( Prop_Mat[i].pTextureFilename == NULL)
			mtm->Textures[i]=NULL;
		else
			if(FAILED(D3DXCreateTextureFromFile(*_obj_Direct3DDevice, Prop_Mat[i].pTextureFilename, &(mtm->Textures[i]))))
				mtm->Textures[i]=NULL;

	}

	// libration du mesh buffeuris
	if(Mat_buff)
		Mat_buff->Release();

	return mtm;

}

void obj2device_dessin_mesh(unsigned int n, _mesh_ *mtm, LPDIRECT3DDEVICE9 *_obj_Direct3DDevice, LPD3DXMESH *_obj_mesh) {

	for (unsigned int i=0; i<n; i++) {
		(*_obj_Direct3DDevice)->SetMaterial(&(mtm->Materiaux[i]));
		(*_obj_Direct3DDevice)->SetTexture(0, mtm->Textures[i]);
		(*_obj_mesh)->DrawSubset(i);

	}
}
