#include"init_DS.h"

HRESULT LoadDirectSound(LPDIRECTSOUND *ds, LPDIRECTSOUNDBUFFER *buffer, char* filename)
{
	
	HMMIO mmioWave;
	if((mmioWave = mmioOpen(filename, 0, MMIO_READWRITE)) == NULL)
		return E_FAIL;

	MMCKINFO mmckinfoParent;
	//descend jusqu au bloc WAVE
	mmckinfoParent.fccType = mmioFOURCC('W', 'A', 'V', 'E');			
	if(mmioDescend(mmioWave, &mmckinfoParent, NULL, MMIO_FINDRIFF))
	{	mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	MMCKINFO mmckinfoSubchunk;
	//descend jusqu au bloque fmt
	mmckinfoSubchunk.ckid = mmioFOURCC('f', 'm', 't', ' ');
	if(mmioDescend(mmioWave, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK))
	{	mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	//lecture des donnees du fmt
	WAVEFORMATEX wfPCM;
	if(mmioRead(mmioWave, (HPSTR)&wfPCM, mmckinfoSubchunk.cksize) == -1)
	{	mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	mmioAscend(mmioWave, &mmckinfoSubchunk, 0);

	mmckinfoSubchunk.ckid = mmioFOURCC('d', 'a', 't', 'a');
	if(mmioDescend(mmioWave, &mmckinfoSubchunk, &mmckinfoParent, MMIO_FINDCHUNK))
	{	mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	//creation du directsound buffer
	DSBUFFERDESC bufdesc;
	ZeroMemory(&bufdesc, sizeof(bufdesc));
	bufdesc.dwSize		  = sizeof(DSBUFFERDESC);
	bufdesc.dwFlags		  = NULL;
	bufdesc.dwBufferBytes = mmckinfoSubchunk.cksize;
	bufdesc.lpwfxFormat	  = &wfPCM;

	LPDIRECTSOUNDBUFFER lpdsBuffer;

	HRESULT rval = (*ds)->CreateSoundBuffer(&bufdesc,&lpdsBuffer,NULL);
	if(rval != S_OK)
		exit(0);

	LPBYTE lpvAudio1, lpvAudio2;
	DWORD dwWriteBytes1, dwWriteBytes2;

	//verrouille le tampon DirectSound
	HRESULT hr = lpdsBuffer->Lock(0, 0, (LPVOID*)&lpvAudio1, &dwWriteBytes1, (LPVOID*)&lpvAudio2, &dwWriteBytes2, DSBLOCK_ENTIREBUFFER);
	if(hr == DSERR_BUFFERLOST)
	{	lpdsBuffer->Restore();
		hr = lpdsBuffer->Lock(0, 0, (LPVOID*)&lpvAudio1, &dwWriteBytes1, (LPVOID*)&lpvAudio2, &dwWriteBytes2, DSBLOCK_ENTIREBUFFER);
	}

	if(FAILED(hr))
	{	
		if(lpdsBuffer != NULL) {lpdsBuffer->Release(); lpdsBuffer = NULL;}
		
		mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	if(dwWriteBytes1 != mmckinfoSubchunk.cksize)
	{	if(lpdsBuffer != NULL) {lpdsBuffer->Release(); lpdsBuffer = NULL;}
		mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	if(mmioRead(mmioWave, (HPSTR)lpvAudio1, mmckinfoSubchunk.cksize) == -1)
	{	if(lpdsBuffer != NULL) {lpdsBuffer->Release(); lpdsBuffer = NULL;}
		mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	//dverrouille le tampon DirectSound
	if(FAILED(lpdsBuffer->Unlock((LPVOID)lpvAudio1, dwWriteBytes1, (LPVOID)lpvAudio2, dwWriteBytes2)))
	{	if(lpdsBuffer != NULL) {lpdsBuffer->Release(); lpdsBuffer = NULL;}
		mmioClose(mmioWave, 0);
		return E_FAIL;
	}

	//fermture
	mmioClose(mmioWave, 0);

	*buffer = lpdsBuffer;

  return S_OK;
}
