#include "vertices.h"
#include "decl_vertices.h"

HRESULT charge_textures(LPDIRECT3DDEVICE9 *_obj_Direct3DDevice, LPDIRECT3DTEXTURE9 *pTexture, const char *nom) {

	if( FAILED( D3DXCreateTextureFromFile(*_obj_Direct3DDevice, nom, pTexture ) ) )
		return E_FAIL;
	
	return S_OK;
}

HRESULT init_vertices(LPDIRECT3DDEVICE9 *_obj_Direct3DDevice, LPDIRECT3DVERTEXBUFFER9 *_obj_DirectVB, float lng, float larg) {

	HRESULT hr;

	hr = (*_obj_Direct3DDevice)->CreateVertexBuffer( 4 * sizeof(VERTICES), 0, D3DFVF_XYZ|D3DFVF_DIFFUSE|D3DFVF_TEX1, D3DPOOL_DEFAULT, _obj_DirectVB, NULL);
		if (FAILED(hr)) return E_FAIL;

	VERTICES* pVertices;
    
	hr = (*_obj_DirectVB)->Lock( 0, 0, (void**)&pVertices, 0);
		if(FAILED(hr)) return E_FAIL;

    pVertices[0].v = D3DXVECTOR3( -larg/2, -lng/2, 0);
    pVertices[0].couleur    = 0xffffffff;
    pVertices[0].tu    = 0;
    pVertices[0].tv    = 0;
    pVertices[1].v = D3DXVECTOR3( -larg/2, lng/2, 0);
    pVertices[1].couleur    = 0xffffffff;
    pVertices[1].tu    = 0;
    pVertices[1].tv    = 1;
    pVertices[2].v = D3DXVECTOR3( larg/2, -lng/2, 0);
    pVertices[2].couleur    = 0xffffffff;
    pVertices[2].tu    = 1;
    pVertices[2].tv    = 0;
	pVertices[3].v = D3DXVECTOR3( larg/2, lng/2, 0);
    pVertices[3].couleur    = 0xffffffff;
    pVertices[3].tu    = 1;
    pVertices[3].tv    = 1;

    (*_obj_DirectVB)->Unlock();

	return S_OK;
  }